/*************************************************************
	Docs\refs\AN405\AN405.zip:ftdi245.c

	Copyright (c) 2004, Z-World

	This program demonstrates setting up the Rabbit registers
	and external I/O mapping to interface with the FT245BM.
	The main program loop echos any characters received over
	the USB connection.

	PE5 - rd# strobe, active low, address range starting at 0xa000
	PE3 - wr strobe, active high, address range starting at 0x6000
	PE1 - rxf# low when data is ready
	PE0 - txe# low when transmitter is ready
****************************************************************/

#define FT_WR_BASE	0x6000
#define FT_RD_BASE	0xa000

main()
{
unsigned char c;
	WrPortI(SPCR,&SPCRShadow,0x8c);		// slave off, ext. IO
	WrPortI(PEFR,&PEFRShadow,0x28);		// external chipenables

	WrPortI(IB3CR,&IB3CRShadow,0x6c);	// 7wait, write, active high
	WrPortI(IB5CR,&IB5CRShadow,0x58);	// 7wait, read, active low

   BitWrPortI(PBDDR,&PBDDRShadow,1,6); // Pull WI/WU up when not used:
   BitWrPortI(PBDR,&PBDRShadow,1,6);   //  (from FT245BM data sheet)

   while(1){
   	costate {
     		waitfor((RdPortI(PEDR)&0x03)==0x00);
         c = RdPortE(FT_RD_BASE);
      	WrPortE(FT_WR_BASE,NULL,c);
      }
   }
}